function getModeName(mode) {
    var name;
    switch (mode) {
        case 'TEXT':
            name = '文字咨询';
            break;
        case 'VOICE':
            name = '语音咨询';
            break;
        case 'VIDEO':
            name = '视频咨询';
            break;
        case 'FACE':
            name = '线下面询';
            break;
        case 'ALL':
            name = '所有咨询';
            break;
        default:
            name = '';
    }
    return name;
}

function getRankName(rank) {
    var name;
    switch (rank) {
        case 'C1':
            name = '线上·线下咨询师';
            break;
        case 'C2':
            name = '高级咨询师';
            break;
        case 'C3':
            name = '资深咨询师';
            break;
        case 'C4':
            name = '执案咨询师';
            break;
        default:
            name = '';
    }
    return name;
}

function getGenderName(gender) {
    var name;
    switch (gender) {
        case 'M':
            name = '男';
            break;
        case 'F':
            name = '女';
            break;
        case 'm':
            name = '男';
            break;
        case 'f':
            name = '女';
            break;
        default:
            name = '未知';
    }
    return name;
}

function getSpecName(spec) {
    var name;
    switch (spec) {
        case 'ONEHOUR':
            name = '1次';
            break;
        case 'SEVENDAYS':
            name = '7天';
            break;
        case 'THIRTYDAYS':
            name = '30天';
            break;
        default:
            name = '';
    }
    return name;
}

function getDomainName(domain) {
    var name;
    switch (domain) {
        case 'MARRIAGE':
            name = '婚恋';
            break;
        case 'EMOTION':
            name = '情绪';
            break;
        case 'FAMILY':
            name = '家庭';
            break;
        case 'GROWING':
            name = '个人成长';
            break;
        case 'CAREER':
            name = '职场社交';
            break;
        case 'OTHER':
            name = '其他';
            break;
        default:
            name = '';
    }
    return name;
}

function getMoodTitle(mood) {
    var title;
    switch (mood) {
        case 1:
            title = '似乎你心情非常差，快来告诉我可以在哪方面帮到你？';
            break;
        case 2:
            title = '感觉你有些低落，找到愁啥您想获得哪方面帮助呢？';
            break;
        case 3:
            title = '看起来你心情一般，哪方面的事情影响到你呢？';
            break;
        case 4:
            title = '感觉你的心情挺愉悦，你想要在这个APP获得哪方面的心理学内容呢？';
            break;
        case 5:
            title = '你心情一定很好吧，你对哪方面的心理学内容感兴趣呢？';
            break;
        default:
            title = '';
    }
    return title;
}

function getRoomStatusName(status) {
    var name;
    switch (status) {
        case 0:
            name = '待确认';
            break;
        case 1:
            name = '待确认';
            break;
        case 2:
            name = '待咨询';
            break;
        case 3:
            name = '咨询中';
            break;
        case 4:
            name = '已关闭';
            break;
        case 9:
            name = '已过期';
            break;
        default:
            name = '未知';
    }
    return name;
}

function getClendarStatusName(status) {
    var name;
    switch (status) {
        case 1:
            name = '待接';
            break;
        case 2:
            name = '已接';
            break;
        case 3:
            name = '完成';
            break;
        case 4:
            name = '停接';
            break;
        default:
            name = '&nbsp;';
    }
    return name;
}

function getArticleStatusName(status) {
    var name;
    switch (status) {
        case 'DRAFT':
            name = '草稿';
            break;
        case 'APPOVE':
            name = '待审核';
            break;
        case 'REEDIT':
            name = '待修改';
            break;
        case 'PUBLISH':
            name = '已发布';
            break;
        default:
            name = '未知';
    }
    return name;
}

function getOrderStatusName(status) {
    var name;
    switch (status) {
        case 0:
            name = '待选择';
            break;
        case 1:
            name = '待确认';
            break;
        case 2:
            name = '待完成';
            break;
        case 3:
            name = '已完成';
            break;
        case 4:
            name = '已取消';
            break;
        case 5:
            name = '待售后';
            break;
        case 6:
            name = '已关闭';
            break;
        case 9:
            name = '未付款';
            break;
        default:
            name = '未知状态';
    }
    return name;
}

function getConsultantStatusName(status) {
    var name;
    switch (status) {
        case 'SIGNED':
            name = '正式启用';
            break;
        case 'STOP':
            name = '停用处罚';
            break;
        case 'CANCEL':
            name = '取消资格';
            break;
        case 'SUSPEND':
            name = '暂停接单';
            break;
        default:
            name = '未知状态';
    }
    return name;
}

function getDrawStatusName(status) {
    var name;
    switch (status) {
        case 0:
            name = '草稿';
            break;
        case 1:
            name = '待付款';
            break;
        case 2:
            name = '待修改';
            break;
        case 3:
            name = '待咨询师分析';
            break;
        case 4:
            name = '已删除';
            break;
        case 9:
            name = '已分析';
            break;
        default:
            name = '未知状态';
    }
    return name;
}

function getPermName(code) {
    var name;
    switch (code) {
        case 'storage':
            name = '存储空间';
            break;
        case 'microphone':
            name = '麦克风';
            break;
        case 'camera':
            name = '摄像头';
            break;
        case 'location':
            name = '位置信息';
            break;
        default:
            name = '未知权限';
    }
    return name;
}
