function login(data) {
    _post('api/login', data, function(result) {
        if (result && result.type == window.success) {
            handleUser(result.data, '.');
        } else {
            //业务失败
            _toast(result.message, window.toastDuration, 'top');
        }
    });
}
//一种统一处理方法是发送事件到root窗口，然后root窗口在做处理
function handleUser(user, path) {
    $api.setStorage(window.userKey, user);
    switch (user.user_type) {
        case 'ASKER':
            goHome(1);
            //_openWin('asker_index', 'widget://html/asker/index.html');
            break;
        case 'CONSULTANT':
            _openWin('consultant_index', 'widget://html/consultant/index.html');
            //_openWin('consultant_index','widget://html/consultant/index.html');
            break;
        case 'GUIDE':
            _toast('抱歉！还没有开通客服功能');
            break;
        case 'AGENCY':
            _toast('抱歉！还没有开通机构功能');
            break;
        default:
            //TODO 想要做点什么？
            _toast('抱歉！还没有开通内部功能');
    }
    //发送登录成功的事件
    api.sendEvent({
        name: 'event_login',
        extra: user
    });
}

function logout() {
    $.ajax({
        url: window.serverUrl + 'api/logout',
        type: 'get',
        data: {},
        async: true,
        timeout: window.ajaxTimeout,
        beforeSend: function(xhr, settings) {
            _loading();
        },
        complete: function(xhr, status) {
            api.hideProgress();
        },
        success: function(result, status, xhr) {
            // 清理本地数据
            if (status && status == 'success') {
                //TODO 跳转到来访者页面，或者统一发事件，在root窗口统一处理
                $api.rmStorage(window.userKey);
                $api.setStorage('tab', 0);
                _toast(status);
                api.sendEvent({
                    name: 'event_logout'
                });

                // api.closeFrameGroup({
                //     name: 'asker_group'
                // });
                // api.closeWin({
                //     name: 'asker_index'
                // });
                goHome(0);
            } else {
                //TODO 特殊情况的处理
                api.toast({
                    msg: '网络连接失败，请检查！'
                });
            }
        },
        error: function(xhr, errorType, error) {
            api.toast({
                msg: '网络连接失败，请检查！'
            });
        }
    });
}

function goHome(status) {
    //跳转到首页，一般用于退出操作，和启动后的操作
    _openWin('asker_index', 'widget://html/asker/index.html', {status : status});
}
