/**
 * 主要处理会话及消息的脚本
 */

// 3、融云初始化并连接监听
function rong_init() {
    // 初始化融云
    // 3.1
    rong.init(function(ret, err) {
        if (ret.status == 'error') {
            _info(err);
        }
    });
    // 3.2 监听融云连接状态
    // 监听连接状态
    rong.setConnectionStatusListener(function(ret, err) {
        var statuMsg = "";
        var rong_statu = ret.result.connectionStatus;
        switch (rong_statu) {
            case "CONNECTED":
                statuMsg = "连接成功";
                break;
            case "CONNECTING":
                statuMsg = "连接中";
                break;
            case "DISCONNECTED":
                statuMsg = "断开连接";
                break;
            case "KICKED":
                statuMsg = "用户账户在其他设备登录，本机会被踢掉线";
                break;
            case "NETWORK_UNAVAILABLE":
                statuMsg = "网络不可用";
                break;
            case "SERVER_INVALID":
                statuMsg = "服务器异常或无法连接";
                break;
            case "TOKEN_INCORRECT":
                statuMsg = "Token 不正确";
                break;
            default:
                statuMsg = "未知错误";
                break;
        }
        _toast(statuMsg);
    });
    // 3.3 监听是否有消息进入
    rong_onMsgListener();
    // 3.4.1 连接
    rong_connect();
}

// 3.4 连接融云
function rong_connect() {
    var _token = userJson.rong_token;
    if (_token) {
        rong.connect({
            token: _token
        }, function(ret, err) {
            if (ret.status == 'success') {
                // 获取会话列表
                //不在这里做拉取列表的动作了
                rong_getConversationList();
            } else {
                _info(err);
            }
        });
    }
}

function rong_deleteMessages(msgid) {
    if (msgid) {
        rong.deleteMessages({
            messageIds: [msgid]
        }, function(ret, err) {
            //删除
        })
    }
}

//显示数字或红点，只做文字聊天的列表，对于咨询师的语音和视频单独处理
function refreshReddot(unread, dots) {
    //清理再设置
    $api.removeCls($api.byId('reddot'), 'aui-badge');
    $api.removeCls($api.byId('reddot'), 'aui-dot');
    $api.text($api.byId('reddot'), '');
    if (unread > 0) {
        $api.addCls($api.byId('reddot'), 'aui-badge');
        $api.text($api.byId('reddot'), unread + '');
    } else {
        if (dots > 0) {
            $api.addCls($api.byId('reddot'), 'aui-dot');
        }
    }
}

//咨询师预约列表的红点，单独使用
function refreshReddot1(unread, dots) {
    //清理再设置
    $api.removeCls($api.byId('reddot1'), 'aui-badge');
    $api.removeCls($api.byId('reddot1'), 'aui-dot');
    $api.text($api.byId('reddot1'), '');
    if (unread > 0) {
        $api.addCls($api.byId('reddot1'), 'aui-badge');
        $api.text($api.byId('reddot1'), unread + '');
    } else {
        if (dots > 0) {
            $api.addCls($api.byId('reddot1'), 'aui-dot');
        }
    }
}

// // 融云发送信息成功后更新会话
// function sendMsgSuccessEnd(ret) {
//     // 接收者ID
//     var targetId = ret.result.message.targetId;
//     // 判断该会话是否存在了，如果存在就上移并更新数据
//     if ($("#msglist ul li[data-targetId='" + targetId + "']").size() > 0) {
//         var $newMsg = $("#msglist ul li[data-targetId='" + targetId + "']");
//         $newMsg.find(".msgnr").text(setLastMsgText(ret.result.message, false));
//         var $clone = $newMsg.clone();
//         // 移除
//         $newMsg.remove();
//         // 在第一次插入
//         $('#msglist ul').prepend($clone);
//     } else {
//         // 插入新的
//         var msgObj = ret.result.message;
//         getUserByID(targetId, msgObj);
//     }
//     // 移除消息ret.result.message.messageId
//     _removeStorage(JSON.stringify(ret.result.message.messageId));
// }

// 4.0 消息监听器，负责监听所有的消息 message listener ,listerning all messages
function rong_onMsgListener() {
    rong.setOnReceiveMessageListener(function(ret, err) {
        // 4.1 广播接收到消息了
        //1、消息监听，一收到消息就分发出去，如果当前界面在某个聊天窗口，如果是发给自己的消息则直接显示在下方
        //2、如果是在会话列表页面，如果收到新消息则需要修改列表上具体会话数量和最后一条的内容
        //3、如果是在系统通知页面，则在最上面显示一条
        _sendEvent("receivedMsg", ret.result.message);
        //TODO 2018-03-19 hanyou 暂时屏蔽对会话列表的处理
        // 判断是否首次获取，避免重复插入
        // if (!isFirst) {
        //     // 发送者ID
        //     var rongID = ret.result.message.senderUserId;
        //     // 判断是否是单聊
        //     if (ret.result.message.conversationType == "PRIVATE") {
        //         rongID = ret.result.message.senderUserId;
        //     }
        //     // 判断是否是群聊
        //     else if (ret.result.message.conversationType == "GROUP") {
        //         rongID = ret.result.message.targetId;
        //     }
        //     // 判断该会话是否存在了，如果存在就上移并更新数据
        //     if ($("#msglist ul li[data-targetId='" + rongID + "']").size() > 0) {
        //         var $newMsg = $("#msglist ul li[data-targetId='" + rongID + "']");
        //         $newMsg.find(".msgnr").text(setLastMsgText(ret.result.message, false));
        //         $newMsg.find(".btime").text(_formatDate(ret.result.message.receivedTime));
        //         var $clone = $newMsg.clone();
        //         // 移除
        //         $newMsg.remove();
        //         // 在第一次插入
        //         $('#msglist ul').prepend($clone);
        //     } else {
        //         // 插入新的
        //         var msgObj = ret.result.message;
        //         getUserByID(rongID, msgObj);
        //     }
        // }
        // if (!isFirst) {
        //     // 状态栏提醒
        //     api.notification({
        //         vibrate: [300, 500],
        //         sound: 'default',
        //         light: false,
        //         notify: {
        //             title: '您有新消息',
        //             content: ret.result.message.content.text != undefined ? ret.result.message.content.text : "",
        //             updateCurrent: false,
        //             extra: JSON.stringify(ret.result.message)
        //         }
        //     }, function(ret, err) {});
        // }
    })
}

// 6.0 统一发送消息接口
// @msgType：消息类型，文字，图片，语言，地图，天气
// @conversationType：会话类型，单聊（PRIVATE），讨论组（DISCUSSION），群组（GROUP），聊天室（CHATROOM），客服（CUSTOMER_SERVICE），（SYSTEM）
// @targetId：接受方ID，可以是用户 Id、讨论组 Id、群组 Id 或聊天室 Id
// @content：发送内容
// @extra：用户自定义数据,一般extra是用户+token组装的json字符串
function rong_sendMsg(msgType, conversationType, targetId, content, extra) {
    switch (msgType) {
        // 发送文字消息
        case "text":
            rong.sendTextMessage({
                conversationType: conversationType,
                targetId: targetId,
                text: content,
                extra: extra
            }, function(ret, err) {
                if (ret.status == 'prepare') {
                    // 存储当前发送信息
                    _setStorage(JSON.stringify(ret.result.message.messageId), ret);
                    // 广播消息，发送准备中
                    _sendEvent("sendMsgPrepare", ret.result.message);
                } else if (ret.status == 'success') {
                    // 广播消息，发送成功
                    _sendEvent("sendMsgSuccess", ret.result.message);
                    // 设置发送会话
                    //sendMsgSuccessEnd(_getStorage(JSON.stringify(ret.result.message.messageId)));
                } else if (ret.status == 'error') {
                    // 广播消息，发送失败
                    _sendEvent("sendMsgError", {
                        errcode: err.code,
                        messageId: ret.result.message.messageId,
                        msgObj: {
                            msgType: msgType,
                            conversationType: conversationType,
                            targetId: targetId,
                            content: content,
                            extra: extra
                        }
                    });
                }
            });
            break;
            // 发送语音
        case "voice":
            rong.sendVoiceMessage({
                conversationType: conversationType,
                targetId: targetId,
                voicePath: content,
                duration: $api.strToJson(extra).duration,
                extra: extra
            }, function(ret, err) {
                if (ret.status == 'prepare') {
                    // 存储当前发送信息
                    _setStorage(JSON.stringify(ret.result.message.messageId), ret);
                    // 广播消息，发送准备中
                    _sendEvent("sendMsgPrepare", ret.result.message);
                } else if (ret.status == 'success') {
                    // 广播消息，发送成功
                    _sendEvent("sendMsgSuccess", ret.result.message);
                    // 设置发送会话
                    //sendMsgSuccessEnd(_getStorage(JSON.stringify(ret.result.message.messageId)));
                } else if (ret.status == 'error') {
                    // 广播消息，发送失败
                    _sendEvent("sendMsgError", {
                        errcode: err.code,
                        messageId: ret.result.message.messageId,
                        msgObj: {
                            msgType: msgType,
                            conversationType: conversationType,
                            targetId: targetId,
                            content: content,
                            extra: extra
                        }
                    });
                }
            });
            break;
            // 发送图片
        case "image":
            rong.sendImageMessage({
                conversationType: conversationType,
                targetId: targetId,
                imagePath: content,
                extra: extra
            }, function(ret, err) {
                if (ret.status == 'prepare') {
                    // 存储当前发送信息
                    _setStorage(JSON.stringify(ret.result.message.messageId), ret);
                    // 广播消息，发送准备中
                    _sendEvent("sendMsgPrepare", ret.result.message);
                } else if (ret.status == 'progress') {
                    // 广播消息，发送过程中
                    _sendEvent("sendMsgProgress", ret.result.progress);
                } else if (ret.status == 'success') {
                    // 广播消息，发送成功
                    _sendEvent("sendMsgSuccess", ret.result.message);
                    // 设置发送会话
                    //sendMsgSuccessEnd(_getStorage(JSON.stringify(ret.result.message.messageId)));
                } else if (ret.status == 'error') {
                    // 广播消息，发送失败
                    _sendEvent("sendMsgError", {
                        errcode: err.code,
                        messageId: ret.result.message.messageId,
                        msgObj: {
                            msgType: msgType,
                            conversationType: conversationType,
                            targetId: targetId,
                            content: content,
                            extra: extra
                        }
                    });
                }
            });
            break;
            // 发送图文
        case "richmsg":
            rong.sendRichContentMessage({
                conversationType: conversationType,
                targetId: targetId,
                title: $api.strToJson(extra).title,
                description: $api.strToJson(extra).description,
                imageUrl: content,
                extra: extra
            }, function(ret, err) {
                if (ret.status == 'prepare') {
                    // 存储当前发送信息
                    _setStorage(JSON.stringify(ret.result.message.messageId), ret);
                    // 广播消息，发送准备中
                    _sendEvent("sendMsgPrepare", ret.result.message);
                } else if (ret.status == 'success') {
                    // 广播消息，发送成功
                    _sendEvent("sendMsgSuccess", ret.result.message);
                    // 设置发送会话
                    //sendMsgSuccessEnd(_getStorage(JSON.stringify(ret.result.message.messageId)));
                } else if (ret.status == 'error') {
                    // 广播消息，发送失败
                    _sendEvent("sendMsgError", {
                        errcode: err.code,
                        messageId: ret.result.message.messageId,
                        msgObj: {
                            conversationType: conversationType,
                            targetId: targetId,
                            title: $api.strToJson(extra).title,
                            description: $api.strToJson(extra).description,
                            imageUrl: content,
                            extra: extra
                        }
                    });
                }
            });
            break;
            // 发送位置信息
        case "location":
            rong.sendLocationMessage({
                conversationType: conversationType,
                targetId: targetId,
                latitude: $api.strToJson(extra).lat,
                longitude: $api.strToJson(extra).lon,
                poi: $api.strToJson(extra).poi,
                imagePath: content,
                extra: extra
            }, function(ret, err) {
                if (ret.status == 'prepare') {
                    // 存储当前发送信息
                    _setStorage(JSON.stringify(ret.result.message.messageId), ret);
                    // 广播消息，发送准备中
                    _sendEvent("sendMsgPrepare", ret.result.message);
                } else if (ret.status == 'progress') {
                    // 广播消息，发送过程中
                    _sendEvent("sendMsgProgress", ret.result.progress);
                } else if (ret.status == 'success') {
                    // 广播消息，发送成功
                    _sendEvent("sendMsgSuccess", ret.result.message);
                    // 设置发送会话
                    //sendMsgSuccessEnd(_getStorage(JSON.stringify(ret.result.message.messageId)));
                } else if (ret.status == 'error') {
                    // 广播消息，发送失败
                    _sendEvent("sendMsgError", {
                        errcode: err.code,
                        messageId: ret.result.message.messageId,
                        msgObj: {
                            conversationType: conversationType,
                            targetId: targetId,
                            latitude: $api.strToJson(extra).lat,
                            longitude: $api.strToJson(extra).lon,
                            poi: $api.strToJson(extra).poi,
                            imagePath: content,
                            extra: extra
                        }
                    });
                }
            });
            break;
            // 发送命令消息（自定义消息)
        case "cmd":
            rong.sendCommandNotificationMessage({
                conversationType: conversationType,
                targetId: targetId,
                name: $api.strToJson(extra).name,
                data: extra
            }, function(ret, err) {
                if (ret.status == 'prepare') {
                    // 存储当前发送信息
                    _setStorage(JSON.stringify(ret.result.message.messageId), ret);
                    // 广播消息，发送准备中
                    _sendEvent("sendMsgPrepare", ret.result.message);
                } else if (ret.status == 'success') {
                    // 广播消息，发送成功
                    _sendEvent("sendMsgSuccess", ret.result.message);
                    // 设置发送会话
                    //sendMsgSuccessEnd(_getStorage(JSON.stringify(ret.result.message.messageId)));
                } else if (ret.status == 'error') {
                    // 广播消息，发送失败
                    _sendEvent("sendMsgError", {
                        errcode: err.code,
                        messageId: ret.result.message.messageId,
                        msgObj: {
                            conversationType: conversationType,
                            targetId: targetId,
                            name: $api.strToJson(extra).name,
                            data: extra
                        }
                    });
                }
            });
            break;
        default:
            break;
    }
}

// 7.0  获取最新消息记录
// @conversationType：会话类型，单聊（PRIVATE），讨论组（DISCUSSION），群组（GROUP），聊天室（CHATROOM），客服（CUSTOMER_SERVICE），（SYSTEM）
// @targetId：接受方ID，可以是用户 Id、讨论组 Id、群组 Id 或聊天室 Id
function rong_getLatestMessages(conversationType, targetId) {
    rong.getLatestMessages({
        conversationType: conversationType,
        targetId: targetId,
        count: 50
    }, function(ret, err) {
        // 广播事件，通知成功获取到数据
        _sendEvent("getNewMsgEnd", ret.result);
    })
}

// 16、 获取历史纪录
// @conversationType：会话类型，单聊（PRIVATE），讨论组（DISCUSSION），群组（GROUP），聊天室（CHATROOM），客服（CUSTOMER_SERVICE），（SYSTEM）
// @targetId：接受方ID，可以是用户 Id、讨论组 Id、群组 Id 或聊天室 Id
// @oldestMessageId：最后消息id
function rong_getHistoryMessages(conversationType, targetId, oldestMessageId) {
    rong.getHistoryMessages({
        conversationType: 'PRIVATE',
        targetId: targetId,
        oldestMessageId: oldestMessageId,
        count: 20
    }, function(ret, err) {
        // 广播事件，通知成功获取到数据
        _sendEvent("getHistoryMsgEnd", ret.result);
    })
}

// 20、退出登录
function rong_logout() {
    rong.logout(function(ret, err) {
        if (ret.status == 'error') {
            _info(err);
        }
    });
}

// 22 断开连接
function rong_disconnect() {
    rong.disconnect(false);
}


// 24 删除会话
function rong_removeConversation(conversationType, targetId) {
    rong.removeConversation({
        conversationType: conversationType,
        targetId: targetId
    }, function(ret, err) {
        if (ret.status == "success") {
            // 删除会话成功
            _sendEvent("removeChatSuccess");
        }
    })
}

// 清除会话未读数
function rong_clearMessagesUnreadStatus(conversationType, targetId) {
    rong.clearMessagesUnreadStatus({
        conversationType: conversationType,
        targetId: targetId
    }, function(ret, err) {})
}

// 获取所有未读消息
function rong_getTotalUnreadCount() {
    rong.getTotalUnreadCount(function(ret, err) {
        // 状态栏提醒
        api.notification({
            vibrate: [300, 500],
            sound: 'default',
            light: false,
            notify: {
                title: '您有' + ret.result + '条未读消息',
                content: '您有' + ret.result + '条未读消息',
                updateCurrent: false,
                extra: JSON.stringify(ret.result.message)
            }
        }, function(ret, err) {});
    });
}

// 设置最后消息文本
function setLastMsgText(msgObj, isConversationList) {
    // 获取消息类型
    var objectName = msgObj.objectName;
    var returnMsg = "";
    switch (objectName) {
        // 文本类型
        case "RC:TxtMsg":
            if (isConversationList) {
                returnMsg = "[文本消息]：" + msgObj.latestMessage.text;
            } else {
                returnMsg = "[文本消息]：" + msgObj.content.text;
            }
            break;
            // 语音类型
        case "RC:VcMsg":
            returnMsg = "[语音消息]：";
            break;
            // 图片消息
        case "RC:ImgMsg":
            returnMsg = "[图片消息]：";
            break;
    }
    return returnMsg;
}
